// dokumentace => dokumentace.txt
// cislo: 09
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    memomapa: TMemo;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Image: TImage;
    Label1: TLabel;
    Image1: TImage;
    Label2: TLabel;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    memotrasa: TMemo;
    Button4: TButton;
    OpenDialog2: TOpenDialog;
    memoprojtrasa: TMemo;
    Timer: TTimer;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure hledejtrasu(x,y:integer);
    procedure Button4Click(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  filename: string;
implementation

{$R *.dfm}

procedure Tform1.hledejtrasu(x,y:integer);    // procedure na hledn cesty
var
  liney:string;
begin
   y:=memomapa.Lines.Count-y;  //pepotn index

   liney:=memomapa.Lines[y];

   if (liney[x] = 'C') or(liney[y]='C') then  //jestlie je cl
     begin
       memotrasa.Lines.SaveToFile(filename);
       showmessage('Done !');
       close;
     end;          
     
        //zjitovn trasy
        
   if liney[x-1] = ':' then         //hledm cestu vedle aktulnho polka....
    begin
      memotrasa.Lines.Add('1,0');
      hledejtrasu(x+1,y);        // a kdytak volm znovu s jinm parametrem...
    end;

   if (liney[x+1] = ':') then
    begin
      memotrasa.Lines.Add('-1,0');
      hledejtrasu(x-1,y);
    end;

  if (liney[y+1] = ':')then
    begin
      memotrasa.Lines.Add('0,1');
      hledejtrasu(x,y+1);
    end;

  if (liney[y-1] = ':') then
    begin
      memotrasa.Lines.Add('0,-1');
      hledejtrasu(x,y-1);
    end;

  if (liney[y-2] = ':') then
    begin
      memotrasa.Lines.Add('1,1');
      hledejtrasu(x+1,y+1);
    end;

end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i,j,pocet:integer;
  ok:boolean;
  c:char;
  buffer:string;
begin
  pocet:=0;               //inicializace
  memomapa.Lines.Clear;
  
  if opendialog1.Execute then
    begin
      memomapa.Lines.LoadFromFile(opendialog1.FileName);      //natu
    end;
  for i:=0 to memomapa.Lines.Count-1 do
    for j:=1 to length(memomapa.Lines[i]) do   // projdm vechny znaky na kadym dku
      begin
        if (memomapa.Lines.Count > 255) or (length(memomapa.Lines[i]) > 255) then    // kontrola rozmru
          begin
            showmessage('Chyba mapy !');
            break;      //vysko
          end;
       end;

  for i:=0 to memomapa.Lines.Count-1 do
    for j:=1 to length(memomapa.Lines[i]) do
      begin
        buffer:=memomapa.Lines[i];
        c:=buffer[j];
        if (c='X') or (c=':') or (c='.') or (c='S') or (c='C') then    //kontrola povolench znak
          ok:=true
        else
          ok:=false;
        if c='S' then          // kontrola potu start  ( ne vce jak jeden
          pocet:=pocet+1;
        if pocet > 1 then
          ok:=false;
      end;

      
  if ok=false then                //vyhodnocen chyb
    showmessage('Chyba mapy !')
  else                         // kdy je vecjno v podku....
    begin
      button2.Enabled:=true;
      button3.Enabled:=true;
      button4.Enabled:=true;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i,j,delka:integer;
  line:string;
  znak:char;

begin
  // zde jde jednodue resizovat
  delka:=10;

  for i:=0 to memomapa.Lines.Count-1 do     // projdm vechny znaky v souboru
    for j:=1 to length(memomapa.Lines[i]) do
      begin
        line:=memomapa.Lines[i];
        znak:=line[j];
        image.Width:=memomapa.Lines.Count*10;
        image.Height:=length(memomapa.Lines[i])*10;
        if znak = 'X' then                   // pak kreslm pslun polko
          begin
            image.Canvas.Brush.Color:=clblack;    //jin barva
            image.Canvas.Pen.Width:=1;
            image.Canvas.Rectangle((j-1)*delka,i*delka,j*delka,(i+1)*delka);    //tverec :)
          end;
        if znak = '.' then
          begin
            image.Canvas.Brush.Color:=clGray;
            image.Canvas.Pen.Width:=1;
            image.Canvas.Rectangle((j-1)*delka,i*delka,j*delka,(i+1)*delka);
          end;
        if znak = ':' then
          begin
            image.Canvas.Brush.Color:=clRed;
            image.Canvas.Pen.Width:=1;
            image.Canvas.Rectangle((j-1)*delka,i*delka,j*delka,(i+1)*delka);
          end;
        if znak = 'S' then
          begin
            image.Canvas.Brush.Color:=clYellow;
            image.Canvas.Pen.Width:=1;
           image.Canvas.Rectangle((j-1)*delka,i*delka,j*delka,(i+1)*delka);
          end;
        if znak = 'C' then
          begin
            image.Canvas.Brush.Color:=clBlue;
            image.Canvas.Pen.Width:=1;
           image.Canvas.Rectangle((j-1)*delka,i*delka,j*delka,(i+1)*delka);
          end;
      end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // vykreslen legendy
  image1.Canvas.Brush.Color:=clblack;
  image1.Canvas.Rectangle(0,0,25,25);

  image2.Canvas.Brush.Color:=clGray;
  image2.Canvas.Rectangle(0,0,25,25);

  image5.Canvas.Brush.Color:=clred;
  image5.Canvas.Rectangle(0,0,25,25);

  image3.Canvas.Brush.Color:=clYellow;
  image3.Canvas.Rectangle(0,0,25,25);

  image4.Canvas.Brush.Color:=clBlue;
  image4.Canvas.Rectangle(0,0,25,25);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  line:string;
  x,y,i,j:integer;
  znak:char;
begin
  if savedialog1.Execute then
    begin
      filename:=savedialog1.FileName;
    end;
    
  for i:=0 to memomapa.Lines.Count-1 do        //projdm vechny znaky
    for j:=1 to length(memomapa.Lines[i]) do
      begin
        line:=memomapa.Lines[i];     //beru znak ze dku
        znak:=line[j];
        if znak='S' then
          begin
            y:=(memomapa.Lines.Count - i); // pepotn index
            x:=j;
            label9.Caption:='Startovac pozice: X = '+inttostr(x)+'; Y= '+inttostr(y);
          end;

        if znak='C' then
          begin
            y:=(memomapa.Lines.Count - i); // pepotn index
            x:=j;
            label10.Caption:='Nejbli cl: X = '+inttostr(x)+'; Y= '+inttostr(y);
          end;

      end;

  //trasa
  hledejtrasu(x,y);     //hledm trasu
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if opendialog2.Execute then
    begin
      memoprojtrasa.Lines.LoadFromFile(opendialog2.FileName);
      timer.Enabled:=true;
      button5.Enabled:=true;  // aktivace ovldacho tlatka
    end;
end;

procedure TForm1.TimerTimer(Sender: TObject);
var
  i,j,x,y:integer;
  temp,line:string;
begin
  image.Canvas.Brush.Color:=cllime;  // nastaven na kreslen na canvas
  image.Canvas.Pen.Width:=1;

  //projdm trasu

  for i:=0 to memoprojtrasa.Lines.Count-1 do     //projdm vechny znaky
    for j:=0 to length(memoprojtrasa.Lines[i]) do
      begin
        temp:=memoprojtrasa.Lines[i];
        if temp[1]<>'-' then
          begin        // kontroly proti zpornm hodnot 
            x:=strtoint(temp[1]);
            temp:=memoprojtrasa.Lines[i];
            if temp[4] <> '-' then
              y:=strtoint(temp[4]);
            if temp[4] = '-' then       // hldj
              y:=strtoint(temp[5]);
          end;
          
        if temp[1]='-' then
          begin
            x:=strtoint(temp[2]);
            temp:=memoprojtrasa.Lines[i];
            if temp[4] = '-' then
              y:=strtoint(temp[6]);
            if temp[4] <> '-' then
              y:=strtoint(temp[5]);
          end;
          line:=memomapa.Lines[i];
        image.Canvas.Rectangle((j-1)*10,i*10,j*10,(i+1)*10); //nakleslm jedouc auto
      end;

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  //interakce
  //ovldn auta
  if button5.Caption = 'Zastavit projdjc auto' then
    begin
      timer.Enabled:=false;
      button5.Caption := 'Rozjet projdjc auto'
    end
  else
    begin
      timer.Enabled:=true;
      button5.Caption := 'Zastavit projdjc auto'
    end;

  
end;

end.
